/* 
 * CSE142, 98 Autumn
 * Homework 4
 * Rain Gods and Goddesses

  FINAL VERSION

  
 * NAME: Iliana Avila-Campillo
 * STUDENT #:  9829262
 * SECTION: AE (Liang Sung).
 */

/* There's a landscape in the background...

*/

#include "gp142.h"
#include <stdio.h>
#include <math.h>


#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/

#define BUTTON_HEIGHT  	33
#define BUTTON_WIDTH 	100
#define NUM_BUTTONS 	10

/* decrease bottom_y by this number so that it moves lower in the
   screen  */

#define DROP_SPEED 11

/*color of letter on buttons*/

#define SELECTED_COLOR   RED	 
#define UNSELECTED_COLOR BLUE

#define MAX_PRECIP_EVENTS	500

	/*This is the total number of drops possible at one time.*/

/* y-ccordinate of the top of the "dirt" in the landscape*/

#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */

#define FILL 0

/* Types of precipitations we support */

#define NONE    0
#define RAIN    1 
#define SNOW    2
#define HAIL    3
#define DAY     4
#define NIGHT   5

/*if you add new types of percip, you may need to change this*/

#define MAX_PRECIP_TYPES 2

/*Possible places for mouse clicks*/

#define BUTTON 1

	/*The above means you clicked on SOME button (doesn't say which one yet)*/

#define DIRT 2

	/*The above means you clicked in the dirt area */



/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/

void DrawButtons(int current_precip, int current_color, int current_time, int ufo);

/*Clear all percipitation, so the landscape is just as originally*/

void ClearAllPrecipitation(int precip_type[]);


/*render (draw) all the precipitation*/

void DrawAllPrecipitation(int precip_type[], int bottom_x[], int bottom_y[], 
		 int precip_color[], int drops_count);

void DrawLandscape(int sun_x, int sun_y, int moon_x, int moon_y, int current_time, 
				   int star_color, int c1x, int c1y, int c2x, int c2y, int c3x, int c3y);

void DrawTree(int trunk_x, int trunk_y1, int trunk_y2, int tree_y_center);

void DrawRowTrees( int trunk_x, int trunk_y1, int trees);

void HandleKey (char key_hit,int drops_count, int bottom_x[]);

void DrawRainDrop (int x, int y, int color);

void DrawSnowDrop (int x, int y, int color);

void DrawHailDrop (int x, int y, int color);

void DrawUFO( int x, int y);

/*Return an integer which tells what KIND of click there was */

int  ClassifyMouseClick(int mouse_x, int mouse_y);


/*Given that a button was click, call an appropriate function to handle it*/

void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant, int *current_time, int *ufo);


		   
/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/

int main(void)
{

	
  int quit = FALSE;
  int mouse_x, mouse_y;
  int ufo_x, ufo_y;
  int j,i;
  int drops_count;
  char key_hit;
  int ufo = FALSE;

  int sun_x =GP142_XMAX - 60, sun_y = GP142_YMAX - 45;
  int moon_x=GP142_XMAX - 60, moon_y= GP142_YMAX - 45, star_color = WHITE;
  int c1x= 80, c1y=90,c2x=-80,c2y=70,c3x=160,c3y=180; /* coordenates for clouds */
  
/* 
   * The next arrays tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */

  int precip_type[MAX_PRECIP_EVENTS];
  int bottom_x[MAX_PRECIP_EVENTS];
  int bottom_y[MAX_PRECIP_EVENTS];
  int precip_color[MAX_PRECIP_EVENTS];

 
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  int current_time = DAY;
  
  /*This flag will be true if all weather should be cleared*/
  
  int clear_flag = FALSE;

  
  /*what kind of click was there?*/
  
  int mouse_click;

  
  int event; /*the most recent GP142 event*/

 

  /*
   * INITIALIZATIONS
   */

      


  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  for( j = 0; j < MAX_PRECIP_EVENTS; j++)
  {
	  precip_type[j] = NONE;

  }


  DrawLandscape(sun_x, sun_y, moon_x, moon_y, current_time, star_color, c1x, c1y, c2x, c2y, c3x, c3y);

  DrawButtons(current_precip, current_color, current_time, ufo);	  /* Show the buttons...*/ 
  
  ClearAllPrecipitation (precip_type);


  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  
  i = 0;
  
  drops_count = 0;
  
  while (!quit) {  /*this is the famous "event loop" */


	  
    star_color = YELLOW;


	/*find out what has happened */
	
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
    
	switch (event) {
    
	case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		if(key_hit)
			HandleKey(key_hit, drops_count, bottom_x);
		


      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
		
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	
	  if (mouse_click == BUTTON) {
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag, &current_time, &ufo);

		
	

		if (clear_flag)
			ClearAllPrecipitation(precip_type);


		 
	}else if(mouse_click != BUTTON && ufo == TRUE)
	
	  {
		
		ufo_x = mouse_x;
		ufo_y = mouse_y;

	
	}else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE)){
			
        /* copy the current information for one drop into array elements for the 
		   DrawAllPrecipitation function*/
	
	
		bottom_x[i]     = mouse_x;
	
		bottom_y[i]     = mouse_y;
		
		precip_color[i] = current_color;
		
		precip_type[i]  = current_precip;

		drops_count = drops_count + 1;

		DrawAllPrecipitation(precip_type, bottom_x, bottom_y, precip_color, drops_count);

	
        i = i+1;


	}
      
      break; 

    case GP142_PERIODIC:
      	
        /* this if statement makes the drops reapear at top of the screen */

		if(star_color == WHITE)
		{star_color = YELLOW;}
		else{ star_color = WHITE;}
		
		
		for( j=0; j < drops_count; j++)

		{
		
		
		   if(bottom_y[j] < -GP142_YMAX  - 30 )
		   {
		    	bottom_y[j] = -bottom_y[j];
		   }

		  /* this decreases the y coordenates so that the drops fall */
		
		   bottom_y[j] = bottom_y[j] - DROP_SPEED;

		
		} /* end of for loop */


	

		/*and change the sun's position a little bit*/

		if( current_time == DAY)
		{
		  sun_x= sun_x - 2;
		  
		  if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -3;}


		  /* make the clouds move */
			c1x--;
			if(c1x<-GP142_XMAX-30){
				c1x= -c1x;
			}
			c2x--;
			if(c2x< -GP142_XMAX-30){
				c2x=-c2x;}
			c3x--;
			if(c2x< -GP142_XMAX-30){
				c3x=-c3x;}

				
		  /* change the moon's position */

		}else{
			moon_x--;
			if (moon_x < -GP142_XMAX - 30){
				moon_x = - moon_x -1;
				moon_y = moon_y -1;}

			
			   
		
		}
  
      break;

    default:

		
      break;
	
    }  /*end switch */

    /* Redraw everything */


    
	DrawLandscape(sun_x, sun_y, moon_x, moon_y, current_time, star_color,c1x,c1y,c2x,c2y,c3x,c3y);
    
	DrawButtons(current_precip, current_color, current_time, ufo);
    
	DrawAllPrecipitation(precip_type, bottom_x, bottom_y, precip_color, drops_count);
    
	if(ufo){
		DrawUFO(ufo_x, ufo_y);}

}  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  
  return 0;



}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased.
	*/
	
	void  ClearAllPrecipitation(int precip_type[MAX_PRECIP_EVENTS])
{
  
  int i;

  for(i=0; i < MAX_PRECIP_EVENTS; i++)

  {
	  precip_type[i] = NONE;

  }


}



#define RAINDROP_WIDTH 1

void DrawRainDrop (int x, int y, int color) { 
	
	GP142_lineXY(color, x, y, x + 1, y+8, RAINDROP_WIDTH);

}




void DrawSnowDrop (int x, int y, int color) {

 GP142_printfXY(color, x, y, 15,"*");

}





void DrawHailDrop (int x, int y, int color) {
	GP142_rectangleXY(color, x, y, x+2, y+2, FILL);
}





void DrawAllPrecipitation(int precip_type[], int x[], int y[], int color[], int drops_count)
{


	int i;

	for( i=0; i < drops_count; i++){



	if (y[i] >= TOP_OF_DIRT - 20) {
		switch (precip_type[i]) {
		case RAIN:
			DrawRainDrop (x[i], y[i], color[i]);
			break;
		case SNOW:
			DrawSnowDrop (x[i], y[i], color[i]);
			break;

		case HAIL:
			DrawHailDrop (x[i], y[i], color[i]);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
			
		}/* end of if */

	} /* end of loop */


}





void HandleKey ( char key_hit, int drops_count, int bottom_x[] )

{  /* if user types repeatedly R or L the precipitation will move
      to the right or left */

	int i = 0;

	switch( key_hit ){

    case'r':
    case'R':
		for(i=0; i < drops_count; i++)
		{
			bottom_x[i] = bottom_x[i] + 3;

		}
		break;
	case 'l':
	case 'L':
		for(i=0; i < drops_count; i++)
		{
			bottom_x[i] = bottom_x[i] - 3;

		}
		break;
	default:
		break;
	
	}

}



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}






void DrawUFO(int x, int y)

{
	
	GP142_circleXY(BLUE, x+30, y+17, 15);
	GP142_ovalXY(BLACK, x,y, x+60, y+25, FILL);
	GP142_circleXY(YELLOW, x+4, y+13, 3);
	GP142_circleXY(YELLOW, x+10, y+13, 3);
	GP142_circleXY(YELLOW, x+16, y+13, 3);
	GP142_circleXY(YELLOW, x+22, y+13, 3);
	GP142_circleXY(YELLOW, x+28, y+13, 3);
	GP142_circleXY(YELLOW, x+34, y+13, 3);
	GP142_circleXY(YELLOW, x+40, y+13, 3);
	GP142_circleXY(YELLOW, x+46, y+13, 3);
	GP142_circleXY(YELLOW, x+52, y+13, 3);
	GP142_circleXY(YELLOW, x+58, y+13, 3);
    GP142_circleXY(ORANGE, x,y, 2);
    GP142_circleXY(ORANGE, x+60,y, 2);
	GP142_lineXY(BLACK,x+5,y+10, x,y,3);
	GP142_lineXY(BLACK,x+53,y+10,x+60,y,3);
}




void DrawLandscape(int sun_x, int sun_y, int moon_x, int moon_y, int current_time,
				   int star_color, int c1x,int c1y, int c2x, int c2y, int c3x, int c3y)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;

int trunk_x;
int trunk_y1;
int trunk_y2;
int tree_y_center;

int trees;
int sky_color;



if(current_time == DAY){
	sky_color = ICE_BLUE;
}else{
	sky_color = BLACK;
}

  /* Draw the sky first */
  GP142_rectangleXY(sky_color, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  if(current_time == DAY){

  /* Draw the sun */
	  
	  GP142_circleXY(ORANGE, sun_x, sun_y, 48);
	  GP142_circleXY(RED, sun_x, sun_y, 42);
	  GP142_circleXY(GOLD, sun_x, sun_y, 35);
	  GP142_circleXY(YELLOW, sun_x, sun_y , 30);
	  
  }
  else{/* draw the moon */

	  GP142_circleXY(WHITE, moon_x, moon_y, 40);
	  GP142_circleXY(BLACK, moon_x + 15, moon_y + 5, 30);
  }

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+15, font_size,
	  "Type repeatedly 'R' or 'L' to move precipitation.");
  GP142_printfXY(BLACK, text_offset, -GP142_YMAX, font_size,
	  "To see UFO: click on UFO and then on the screen.");

  if( current_time == DAY)
{
  
  /*Draw the mountains */
  GP142_triangleXY(LT_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(SEA_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);
}else{

	/*Draw the mountains ( different colors )  */
  GP142_triangleXY(BLACK,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(MED_GRAY,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);}


  /* draw the lake */
  
if(current_time == DAY){


  GP142_ovalXY(BLUE, -150, -150, 150, -100, FILL);
  
  GP142_ovalXY(BLUE, -200, -170, 15, -130, FILL);

  GP142_ovalXY(FOREST_GREEN, -100, -150, -60, -130, FILL);}
else{

  GP142_ovalXY(NAVY_BLUE, -150, -150, 150, -100, FILL);
  
  GP142_ovalXY(NAVY_BLUE, -200, -170, 15, -130, FILL);

  GP142_ovalXY(FOREST_GREEN, -100, -150, -60, -130, FILL);}
	

  /* draw the trees */


  /* this is the island tree */
  
  trunk_x = -80;
  trunk_y1 = -140;
  trunk_y2 = -128;

  
  tree_y_center = -120;

  DrawTree(trunk_x, trunk_y1, trunk_y2, tree_y_center); 

  /* draws rows of trees... */

  trunk_x = -200;
  trunk_y1 = TOP_OF_DIRT;
  trees= 5;

  DrawRowTrees(trunk_x, trunk_y1, trees);

  trunk_x = -280;
  trees = 5;

  DrawRowTrees(trunk_x, trunk_y1, trees);
  
  
  trunk_x = 240;
  trees = 7;

  DrawRowTrees(trunk_x, trunk_y1, trees);

  trunk_x = 280;
  trees = 7;

  DrawRowTrees(trunk_x, trunk_y1, trees);



  trunk_x = -240;
  trees   = 7;

  DrawRowTrees(trunk_x, trunk_y1, trees);

 
  trunk_x = 180;
  trunk_y1 = TOP_OF_DIRT - 35;
  trees = 7;
  
  DrawRowTrees(trunk_x, trunk_y1, trees);

  trunk_x = 140;
  trees = 7;

  DrawRowTrees(trunk_x, trunk_y1, trees);

  trunk_x = 100;
  trunk_y1= TOP_OF_DIRT - 50; 
  trees = 7;

  DrawRowTrees(trunk_x, trunk_y1, trees);

  trunk_x = 320;
  trunk_y1 = TOP_OF_DIRT;
  trees = 7;

  DrawRowTrees(trunk_x, trunk_y1, trees);


  
  if(current_time == DAY){
  
  /* draw clouds */

  GP142_ovalXY(WHITE, c1x, c2y, c1x+60, c2y+20, FILL);

  GP142_ovalXY(WHITE, c2x, c2y, c2x+60, c2y+20, FILL);

  GP142_ovalXY(WHITE, c3x, c3y,c3x+60, c3y+20, FILL);}
  else{ /*draw stars*/

	  
	  GP142_ovalXY(BLACK,-120,200, -70, 230, FILL);
	  GP142_ovalXY(BLACK,-150, 190, -100, 220, FILL);
	  
	  GP142_circleXY(star_color, -240, 240, 2);
	  GP142_circleXY(star_color, -200, 235, 2);
	  GP142_circleXY(star_color, -150, 200, 2);
	  GP142_circleXY(star_color, -100, 190, 2);
	  GP142_circleXY(star_color, 100, 245, 2);
	  GP142_circleXY(star_color, 150, 215, 2);
	  GP142_circleXY(star_color, 200, 185, 2);
	  GP142_circleXY(star_color, 250, 240, 2);
	  GP142_circleXY(star_color, 135, 100, 2);


  }



  /* draw the castle */

  GP142_rectangleXY(CHALK,100,-100,120,-80,FILL);

  GP142_rectangleXY(GOLD, 50, -100, 100, -87, FILL);

  GP142_rectangleXY(GOLD,120,-100, 150, -80, FILL);

  GP142_triangleXY(PURPLE, 120, -80, 150, -80, 135, -50, FILL); 

  GP142_lineXY(BLACK, 135, -50, 135, -43, 2 );

  GP142_rectangleXY(ORANGE, 135, -43, 139, -40, FILL);

  GP142_rectangleXY(CHALK,150,-100, 170, -80, FILL);

  GP142_rectangleXY(GOLD, 170, -100, 220, -87, FILL);

  GP142_triangleXY(RED, 150, -80, 170, -80, 160, -70, FILL);

  GP142_lineXY(BLACK, 135, -98, 135,-93, 8);
  
  
  GP142_triangleXY(RED,100,-80, 120, -80, 110, -70, FILL);


} /*end DrawLandscape */




void DrawTree(trunk_x, trunk_y1, trunk_y2, tree_y_center)

{

	
	
	GP142_circleXY(OLIVE, trunk_x, tree_y_center, 8);

	GP142_lineXY(BLACK, trunk_x, trunk_y1, trunk_x, trunk_y2, 3);
	
}


/* draws columns of trees */

void DrawRowTrees( int trunk_x, int trunk_y1, int trees)

{

  int trunk_y2;
  int tree_y_center;
  int tree_count = 0;
  
  while(tree_count < trees){

	  if(trunk_y1 < 0 )

	  {  trunk_y2 = trunk_y1 + 10;
	     tree_y_center = trunk_y2 + 8;
	  
	  }else{
		  trunk_y2 = trunk_y1 - 10;
		  tree_y_center = trunk_y2 - 8;
	  }

	  

	  DrawTree(trunk_x, trunk_y1, trunk_y2, tree_y_center);

	  tree_count = tree_count + 1;

	  trunk_y1 = trunk_y1 - 25;

	  trunk_x = trunk_x - 10;
      
	  
  }/* end of while loop */



}



/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather, int *current_time, int *ufo)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */
  *ufo = FALSE;
  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;

  case 2:
	  *current_precip = HAIL; 
	  break;
  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  case 5:
    *current_color = YELLOW;
    break;
  case 6:
	*ufo = TRUE;
	break;
  case 7:
	  *current_time = DAY;
	  break;
  case 8:
	  *current_time = NIGHT;
	  break;
  case 9:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color, int current_time, int ufo)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(MAGENTA,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Snow");
 
  i-= BUTTON_HEIGHT;
  if (current_precip == HAIL)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Hail");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Hail");

  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Blue");

  i-= BUTTON_HEIGHT;
  if (current_color == YELLOW)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Yellow");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Yellow");

  i-= BUTTON_HEIGHT;

  if( ufo == TRUE)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "UFO");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "UFO"); 

  i-= BUTTON_HEIGHT;
  if(current_time == DAY)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Day");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i , font_size, "Day");

  i-= BUTTON_HEIGHT;
  if(current_time == NIGHT)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Night");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i , font_size, "Night");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Cease!");

}


